=== debian/changelog ===
slicer (3.6.3~svn16075-2) unstable; urgency=low

  * move libMRML.so* to /usr/lib/Slicer3/  (Closes: #615131)
  * fix a FTBFS on Debian GNU/kfreebsd

 -- Dominique Belhachemi <domibel@debian.org>  Thu, 17 Mar 2011 19:04:51 -0400

slicer (3.6.3~svn16075-1) unstable; urgency=low

  * Upload to unstable (Closes: #599096, #614491)
  * New upstream release
  * slicer depends now on slicer-data (= ${source:Version}) (Closes: #591413)

 -- Dominique Belhachemi <domibel@debian.org>  Sat, 19 Feb 2011 22:57:09 -0500

slicer (3.6.2~svn15699-1) experimental; urgency=low

  * New snapshot
  * Built against libkwwidgets1-dev (>=1.0.0~cvs20100930) (Closes: #601306)
  * Removed /usr/lib/InsightToolkit from Slicer3_FORWARD_PATH_INSTALL (Closes: #591339)

 -- Dominique Belhachemi <domibel@debian.org>  Sat, 26 Dec 2010 19:05:18 -0500

slicer (3.6.2~svn15375-1) experimental; urgency=low

  * New snapshot
  * Bump Standards-Version: 3.9.1 (no changes necessary)

 -- Dominique Belhachemi <domibel@debian.org>  Sat, 30 Oct 2010 20:39:41 -0400

slicer (3.6.2~svn15316-1) experimental; urgency=low

  * new patch release candiate

 -- Dominique Belhachemi <domibel@debian.org>  Tue, 31 Aug 2010 21:24:53 -0400

slicer (3.6.0~svn14326-1) experimental; urgency=low

  * new snapshot

 -- Dominique Belhachemi <domibel@debian.org>  Wed, 28 Jul 2010 22:10:40 -0400

slicer (3.6.0~svn13936-2) experimental; urgency=low

  * dependencies
  * Standards-Version: 3.9.0

 -- Dominique Belhachemi <domibel@debian.org>  Thu, 15 Jul 2010 15:56:10 -0400

slicer (3.6.0~svn13936-1) experimental; urgency=low

  * New upstream release
  * Switch to dpkg-source 3.0 (quilt) format

 -- Dominique Belhachemi <domibel@debian.org>  Tue, 20 Apr 2010 02:20:49 -4000
