=== debian/control ===
Source: slicer
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
DM-Upload-Allowed: yes
Uploaders: Dominique Belhachemi <domibel@debian.org>
Build-Depends: debhelper (>= 7), quilt, cmake, tcl-dev, tk-dev, libfftw3-dev,
 libinsighttoolkit3-dev, libkwwidgets1-dev (>=1.0.0~cvs20100930), tcl-vtk (>= 5.6),
 libcurl4-openssl-dev, libvtk5-dev (>= 5.6), libteem1-dev, libopenigtlink1-dev,
 libbz2-dev, libtclap-dev, libgdcm2-dev, python-dev, python-vtk (>= 5.6), subversion
Build-Depends-Indep: doxygen, graphviz
Build-Conflicts: libqt3-mt-dev
Standards-Version: 3.9.1
Vcs-Browser: http://svn.debian.org/wsvn/debian-science/packages/slicer/trunk/?rev=0&sc=0
Vcs-Svn: svn://svn.debian.org/svn/debian-science/packages/slicer/trunk/
Section: graphics
Homepage: http://www.slicer.org/


Package: slicer
Architecture: any
Depends: libslicer3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
 slicer-data (= ${source:Version}), itcl3, iwidgets4, tcllib, tcl8.5-kwwidgets , python-numpy
Description: software package for visualization and image analysis - main application
 Slicer is an application for computer scientists and clinical researchers. The
 platform provides functionality for segmentation, registration and
 three-dimensional visualization of multi-modal image data, as well as advanced
 image analysis algorithms for diffusion tensor imaging, functional magnetic
 resonance imaging and image-guided therapy. Standard image file formats are
 supported, and the  application integrates interface capabilities to biomedical
 research software and image informatics frameworks. 
 .
 3D Slicer main application.


Package: libslicer3
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends} 
Description: software package for visualization and image analysis - runtime
 Slicer is an application for computer scientists and clinical researchers. The
 platform provides functionality for segmentation, registration and
 three-dimensional visualization of multi-modal image data, as well as advanced
 image analysis algorithms for diffusion tensor imaging, functional magnetic
 resonance imaging and image-guided therapy. Standard image file formats are
 supported, and the  application integrates interface capabilities to biomedical
 research software and image informatics frameworks.
 .
 3D Slicer libraries.


Package: libslicer3-dev
Section: libdevel
Architecture: any
Depends: libslicer3 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends} 
Description: software package for visualization and image analysis - development
 Slicer is an application for computer scientists and clinical researchers. The
 platform provides functionality for segmentation, registration and
 three-dimensional visualization of multi-modal image data, as well as advanced
 image analysis algorithms for diffusion tensor imaging, functional magnetic
 resonance imaging and image-guided therapy. Standard image file formats are
 supported, and the  application integrates interface capabilities to biomedical
 research software and image informatics frameworks.
 .
 3D Slicer development files.


Package: slicer-data
Section: doc
Architecture: all
Depends: ${misc:Depends}, tk8.5 | wish
Description: software package for visualization and image analysis - share
 Slicer is an application for computer scientists and clinical researchers. The 
 platform provides functionality for segmentation, registration and
 three-dimensional visualization of multi-modal image data, as well as advanced
 image analysis algorithms for diffusion tensor imaging, functional magnetic
 resonance imaging and image-guided therapy. Standard image file formats are
 supported, and the  application integrates interface capabilities to biomedical
 research software and image informatics frameworks.
 .
 3D Slicer data files.
