=== debian/watch ===
version=3
opts=uversionmangle=s/^/3.4.0~svn/,filenamemangle=s/.*rev=(\d+)&.*/slicer_3.4.0~svn$1.orig.tar.gz/ \
http://viewvc.slicer.org/viewcvs.cgi/branches/Slicer-3-4/ ^/viewcvs.cgi\?rev=(\d+)&view=rev$ \
        debian /bin/sh debian/get-orig-source
